<?php

namespace middlewares;

class SetupGuard implements BaseRequestMiddleware
{

    public static function handle($request): void
    {
        $cfSetup = new \CfSetup(\CfSettings::getInstance()->getConnection());
        $resource = $request->loadResource();
        $isSetupComplete = $cfSetup->isSetupComplete();

        if ($isSetupComplete && is_subclass_of($resource, \Setup::class)) {
            throw new \ResponseException(
                'This operation cannot be performed because the setup is complete.',
                \Response::FORBIDDEN
            );
        } elseif (!$isSetupComplete && !is_subclass_of($resource, \Setup::class) && $resource::class != \SetupStatus::class) {
            throw new \ResponseException(
                'This operation cannot be performed until the setup is completed.',
                \Response::FORBIDDEN
            );
        }
    }
}
