import * as redux from 'redux';
import * as _reduxjs_toolkit from '@reduxjs/toolkit';
import * as immer from 'immer';

declare const sliceName = "releases";
declare const initialState: {
    artifacts: never[];
    byId: {};
    releasesList: {
        searchedIds: never[];
        releaseIds: never[];
        selection: never[];
        sort: {
            direction: string;
            key: string;
        };
        isLoading: undefined;
        searchTerm: string;
        searchTotal: number;
        selectedTags: never[];
        total: number;
        type: string;
        page: number;
        perPage: number;
    };
    tags: never[];
    updateTypes: never[];
    selectedRelease: null;
};
declare const releaseSlice: _reduxjs_toolkit.Slice<{
    artifacts: never[];
    byId: {};
    releasesList: {
        searchedIds: never[];
        releaseIds: never[];
        selection: never[];
        sort: {
            direction: string;
            key: string;
        };
        isLoading: undefined;
        searchTerm: string;
        searchTotal: number;
        selectedTags: never[];
        total: number;
        type: string;
        page: number;
        perPage: number;
    };
    tags: never[];
    updateTypes: never[];
    selectedRelease: null;
}, {
    receiveRelease: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receiveReleases: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receiveReleaseTags: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receiveReleaseTypes: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    removeRelease: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    selectedRelease: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setReleaseListState: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
}, "releases", "releases", _reduxjs_toolkit.SliceSelectors<{
    artifacts: never[];
    byId: {};
    releasesList: {
        searchedIds: never[];
        releaseIds: never[];
        selection: never[];
        sort: {
            direction: string;
            key: string;
        };
        isLoading: undefined;
        searchTerm: string;
        searchTotal: number;
        selectedTags: never[];
        total: number;
        type: string;
        page: number;
        perPage: number;
    };
    tags: never[];
    updateTypes: never[];
    selectedRelease: null;
}>>;
declare const actions: _reduxjs_toolkit.CaseReducerActions<{
    receiveRelease: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receiveReleases: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receiveReleaseTags: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receiveReleaseTypes: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    removeRelease: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    selectedRelease: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setReleaseListState: (state: immer.WritableDraft<{
        artifacts: never[];
        byId: {};
        releasesList: {
            searchedIds: never[];
            releaseIds: never[];
            selection: never[];
            sort: {
                direction: string;
                key: string;
            };
            isLoading: undefined;
            searchTerm: string;
            searchTotal: number;
            selectedTags: never[];
            total: number;
            type: string;
            page: number;
            perPage: number;
        };
        tags: never[];
        updateTypes: never[];
        selectedRelease: null;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
}, "releases">;
declare const _default: redux.Reducer<{
    artifacts: never[];
    byId: {};
    releasesList: {
        searchedIds: never[];
        releaseIds: never[];
        selection: never[];
        sort: {
            direction: string;
            key: string;
        };
        isLoading: undefined;
        searchTerm: string;
        searchTotal: number;
        selectedTags: never[];
        total: number;
        type: string;
        page: number;
        perPage: number;
    };
    tags: never[];
    updateTypes: never[];
    selectedRelease: null;
}>;

export { actions, _default as default, initialState, releaseSlice, sliceName };
